/*!
 * Bootstrap Grunt task for Glyphicons data generation
 * http://getbootstrap.com
 * Copyright 2014 Twitter, Inc.
 * Licensed under MIT (https://github.com/twbs/bootstrap/blob/master/LICENSE)
 */
'use strict';
var fs = require('fs');

module.exports = function generateTbiconsData() {
  // Pass encoding, utf8, so `readFileSync` will return a string instead of a
  // buffer
  var tbiconsFile = fs.readFileSync('less/teambition-ui-icons.less', 'utf8');
  var tbiconsLines = tbiconsFile.split('\n');

  // Use any line that starts with ".glyphicon-" and capture the class name
  var iconClassName = /^\.(icon-[^\s^\:]+)/;
  var tbiconsData = '';
  for (var i = 0, len = tbiconsLines.length; i < len; i++) {
    var match = tbiconsLines[i].match(iconClassName);

    if (match !== null) {
      tbiconsData += '- ' + match[1] + '\n';
    }
  }

  // Create the `_data` directory if it doesn't already exist
  if (!fs.existsSync('docs/_data')) {
    fs.mkdirSync('docs/_data');
  }

  fs.writeFileSync('docs/_data/tbicons.yml', tbiconsData);
};
